Index: palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- palm/trunk/SOURCE/init_3d_model.f90	(revision 4901)
+++ palm/trunk/SOURCE/init_3d_model.f90	(revision 1)
@@ -147,637 +142,215 @@
 ! Description:
 ! ------------
-!> Allocation of arrays and initialization of the 3D model via
-!> a) pre-run the 1D model
-!> or
-!> b) pre-set constant linear profiles
-!> or
-!> c) read values of a previous run
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE init_3d_model
-
-
-    USE advec_ws
+! Allocation of arrays and initialization of the 3D model via
+! a) pre-run the 1D model
+! or
+! b) pre-set constant linear profiles
+! or
+! c) read values of a previous run
+!------------------------------------------------------------------------------!
 
     USE arrays_3d
-
-    USE basic_constants_and_equations_mod,                                                         &
-        ONLY:  barometric_formula, c_p, exner_function, exner_function_invers, g,                  &
-               ideal_gas_law_rho, ideal_gas_law_rho_pt, l_v, pi
-
-    USE bulk_cloud_model_mod,                                                                      &
-        ONLY:  bulk_cloud_model
-
-    USE chem_modules,                                                                              &
-        ONLY:  max_pr_cs ! ToDo: this dependency needs to be removed cause it is ugly #new_dom
-
+    USE averaging
+    USE constants
     USE control_parameters
-
-    USE exchange_horiz_mod,                                                                        &
-        ONLY:  exchange_horiz_2d
-
-    USE grid_variables,                                                                            &
-        ONLY:  dx, dy, ddx2_mg, ddy2_mg
-
+    USE cpulog
     USE indices
-
-    USE kinds
-
-    USE lsf_nudging_mod,                                                                           &
-        ONLY:  ls_forcing_surf
-
-    USE model_1d_mod,                                                                              &
-        ONLY:  init_1d_model, l1d, u1d, v1d
-
-    USE module_interface,                                                                          &
-        ONLY:  module_interface_init_arrays,                                                       &
-               module_interface_init,                                                              &
-               module_interface_init_checks
-
-    USE multi_agent_system_mod,                                                                    &
-        ONLY:  agents_active, mas_init
-
-    USE netcdf_interface,                                                                          &
-        ONLY:  dots_max
-
-    USE netcdf_data_input_mod,                                                                     &
-        ONLY:  add_ghost_layers,                                                                   &
-               char_fill,                                                                          &
-               check_existence,                                                                    &
-               close_input_file,                                                                   &
-               get_attribute,                                                                      &
-               get_variable,                                                                       &
-               init_3d,                                                                            &
-               input_pids_static,                                                                  &
-               inquire_num_variables,                                                              &
-               inquire_variable_names,                                                             &
-               input_file_static,                                                                  &
-               netcdf_data_input_init_3d,                                                          &
-               num_var_pids,                                                                       &
-               open_read_file,                                                                     &
-               pids_id,                                                                            &
-               real_2d,                                                                            &
-               vars_pids
-
-    USE nesting_offl_mod,                                                                          &
-        ONLY:  nesting_offl_init
-
-    USE palm_date_time_mod,                                                                        &
-        ONLY:  init_date_time
-
+    USE interfaces
+    USE model_1d
+    USE particle_attributes
     USE pegrid
-
-#if defined( __parallel )
-    USE pmc_interface,                                                                             &
-        ONLY:  nested_run
-#endif
-
+    USE profil_parameter
     USE random_function_mod
-
-    USE random_generator_parallel,                                                                 &
-        ONLY:  init_parallel_random_generator
-
-    USE read_restart_data_mod,                                                                     &
-        ONLY:  rrd_local, rrd_read_parts_of_global
-
-    USE statistics,                                                                                &
-        ONLY:  hom, hom_sum, mean_surface_level_height, pr_palm, rmask, statistic_regions, sums,   &
-               sums_divnew_l, sums_divold_l, sums_l, sums_l_l, sums_wsts_bc_l, ts_value,           &
-               weight_pres, weight_substep
-
-    USE synthetic_turbulence_generator_mod,                                                        &
-        ONLY:  stg_init
-
-    USE surface_layer_fluxes_mod,                                                                  &
-        ONLY:  init_surface_layer_fluxes
-
-    USE surface_mod,                                                                               &
-        ONLY :  init_single_surface_properties,                                                    &
-                init_surface_arrays,                                                               &
-                init_surfaces,                                                                     &
-                surf_def_h,                                                                        &
-                surf_def_v,                                                                        &
-                surf_lsm_h,                                                                        &
-                surf_usm_h
-
-#if defined( _OPENACC )
-    USE surface_mod,                                                                               &
-        ONLY :  bc_h
-#endif
-
-    USE surface_data_output_mod,                                                                   &
-        ONLY:  surface_data_output_init
-
-    USE transpose_indices
-
+    USE statistics
 
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  i                    !< grid index in x direction
-    INTEGER(iwp) ::  ind_array(1)         !< dummy used to determine start index for external pressure forcing
-    INTEGER(iwp) ::  j                    !< grid index in y direction
-    INTEGER(iwp) ::  k                    !< grid index in z direction
-    INTEGER(iwp) ::  k_surf               !< surface level index
-    INTEGER(iwp) ::  l                    !< running index over surface orientation
-    INTEGER(iwp) ::  m                    !< index of surface element in surface data type
-    INTEGER(iwp) ::  nz_u_shift           !< topography-top index on u-grid, used to vertically shift initial profiles
-    INTEGER(iwp) ::  nz_v_shift           !< topography-top index on v-grid, used to vertically shift initial profiles
-    INTEGER(iwp) ::  nz_w_shift           !< topography-top index on w-grid, used to vertically shift initial profiles
-    INTEGER(iwp) ::  nz_s_shift           !< topography-top index on scalar-grid, used to vertically shift initial profiles
-    INTEGER(iwp) ::  nz_u_shift_l         !< topography-top index on u-grid, used to vertically shift initial profiles
-    INTEGER(iwp) ::  nz_v_shift_l         !< topography-top index on v-grid, used to vertically shift initial profiles
-    INTEGER(iwp) ::  nz_w_shift_l         !< topography-top index on w-grid, used to vertically shift initial profiles
-    INTEGER(iwp) ::  nz_s_shift_l         !< topography-top index on scalar-grid, used to vertically shift initial profiles
-    INTEGER(iwp) ::  nzt_l                !< index of top PE boundary for multigrid level
-    INTEGER(iwp) ::  sr                   !< index of statistic region
-
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE   ::  ngp_2dh_l  !< toal number of horizontal grid points in statistical region on
-                                                             !< subdomain
-
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  ngp_2dh_outer_l    !< number of horizontal non-wall bounded grid points on
-                                                                     !< subdomain
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  ngp_2dh_s_inner_l  !< number of horizontal non-topography grid points on
-                                                                     !< subdomain
-
-    REAL(wp) ::  dx_l !< grid spacing along x on different multigrid level
-    REAL(wp) ::  dy_l !< grid spacing along y on different multigrid level
-
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  init_l                       !< dummy array used for averaging 3D data to obtain
-                                                                         !< inital profiles
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  mean_surface_level_height_l  !< mean surface level height on subdomain
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ngp_3d_inner_l               !< total number of non-topography grid points on subdomain
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ngp_3d_inner_tmp             !< total number of non-topography grid points
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  p_hydrostatic                !< hydrostatic pressure
-
-    REAL(wp), DIMENSION(1:3) ::  volume_flow_area_l     !< area of lateral and top model domain surface on local subdomain
-    REAL(wp), DIMENSION(1:3) ::  volume_flow_initial_l  !< initial volume flow into model domain
-
-    TYPE(real_2d) ::  tmp_2d !< temporary variable to input additional surface-data from static file
-
-    CALL location_message( 'model initialization', 'start' )
-!
-!-- Set reference date-time
-    CALL init_date_time( date_time_str=origin_date_time,                                           &
-                         use_fixed_date=use_fixed_date,                                            &
-                         use_fixed_time=use_fixed_time )
-
-    IF ( debug_output )  CALL debug_message( 'allocating arrays', 'start' )
+    INTEGER ::  i, j, k, sr
+
+    INTEGER, DIMENSION(:), ALLOCATABLE ::  ngp_2dh_l, ngp_3d_inner_l
+
+    INTEGER, DIMENSION(:,:), ALLOCATABLE ::  ngp_2dh_outer_l
+
+    REAL, DIMENSION(1:2) ::  volume_flow_area_l, volume_flow_initial_l
+
+
 !
 !-- Allocate arrays
-    ALLOCATE( mean_surface_level_height(0:statistic_regions),                                      &
-              mean_surface_level_height_l(0:statistic_regions),                                    &
-              ngp_2dh(0:statistic_regions), ngp_2dh_l(0:statistic_regions),                        &
-              ngp_3d(0:statistic_regions),                                                         &
-              ngp_3d_inner(0:statistic_regions),                                                   &
-              ngp_3d_inner_l(0:statistic_regions),                                                 &
-              ngp_3d_inner_tmp(0:statistic_regions),                                               &
-              sums_divnew_l(0:statistic_regions),                                                  &
+    ALLOCATE( ngp_2dh(0:statistic_regions), ngp_2dh_l(0:statistic_regions), &
+              ngp_3d(0:statistic_regions),                                  &
+              ngp_3d_inner(0:statistic_regions),                            &
+              ngp_3d_inner_l(0:statistic_regions),                          &
+              sums_divnew_l(0:statistic_regions),                           &
               sums_divold_l(0:statistic_regions) )
-    ALLOCATE( dp_smooth_factor(nzb:nzt), rdf(nzb+1:nzt), rdf_sc(nzb+1:nzt) )
-    ALLOCATE( ngp_2dh_outer(nzb:nzt+1,0:statistic_regions),                                        &
-              ngp_2dh_outer_l(nzb:nzt+1,0:statistic_regions),                                      &
-              ngp_2dh_s_inner(nzb:nzt+1,0:statistic_regions),                                      &
-              ngp_2dh_s_inner_l(nzb:nzt+1,0:statistic_regions),                                    &
-              rmask(nysg:nyng,nxlg:nxrg,0:statistic_regions),                                      &
-              sums(nzb:nzt+1,pr_palm+max_pr_user+max_pr_cs+max_pr_salsa),                          &
-              sums_l(nzb:nzt+1,pr_palm+max_pr_user+max_pr_cs+max_pr_salsa,0:threads_per_task-1),   &
-              sums_l_l(nzb:nzt+1,0:statistic_regions,0:threads_per_task-1),                        &
+    ALLOCATE( rdf(nzb+1:nzt), uvmean_outflow(nzb:nzt+1),                    &
+              uvmean_outflow_l(nzb:nzt+1) )
+    ALLOCATE( hom_sum(nzb:nzt+1,var_hom,0:statistic_regions),               &
+              ngp_2dh_outer(nzb:nzt+1,0:statistic_regions),                 &
+              ngp_2dh_outer_l(nzb:nzt+1,0:statistic_regions),               &
+              rmask(nys-1:nyn+1,nxl-1:nxr+1,0:statistic_regions),           &
+              sums(nzb:nzt+1,var_sum),                                      &
+              sums_l(nzb:nzt+1,var_sum,0:threads_per_task-1),               &
+              sums_l_l(nzb:nzt+1,0:statistic_regions,0:threads_per_task-1), &
+              sums_up_fraction_l(10,3,0:statistic_regions),                 &
               sums_wsts_bc_l(nzb:nzt+1,0:statistic_regions) )
-    ALLOCATE( ts_value(dots_max,0:statistic_regions) )
-    ALLOCATE( ptdf_x(nxlg:nxrg), ptdf_y(nysg:nyng) )
-
-    ALLOCATE( d(nzb+1:nzt,nys:nyn,nxl:nxr),                                                        &
-              p(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                                    &
-              tend(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-
-    ALLOCATE( pt_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                                 &
-              pt_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                                 &
-              u_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                                  &
-              u_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                                  &
-              u_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                                  &
-              v_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                                  &
-              v_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                                  &
-              v_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                                  &
-              w_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                                  &
-              w_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                                  &
-              w_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-    IF (  .NOT.  neutral )  THEN
-       ALLOCATE( pt_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+    ALLOCATE( km_damp_x(nxl-1:nxr+1), km_damp_y(nys-1:nyn+1) )
+
+    ALLOCATE( rif_1(nys-1:nyn+1,nxl-1:nxr+1), shf_1(nys-1:nyn+1,nxl-1:nxr+1),  &
+              ts(nys-1:nyn+1,nxl-1:nxr+1), us(nys-1:nyn+1,nxl-1:nxr+1),        &
+              usws_1(nys-1:nyn+1,nxl-1:nxr+1), vsws_1(nys-1:nyn+1,nxl-1:nxr+1),&
+              z0(nys-1:nyn+1,nxl-1:nxr+1) )
+
+    IF ( timestep_scheme(1:5) /= 'runge' )  THEN
+!
+!--    Leapfrog scheme needs two timelevels of diffusion quantities
+       ALLOCATE( rif_2(nys-1:nyn+1,nxl-1:nxr+1),  &
+                 shf_2(nys-1:nyn+1,nxl-1:nxr+1),  &
+                 usws_2(nys-1:nyn+1,nxl-1:nxr+1), &
+                 vsws_2(nys-1:nyn+1,nxl-1:nxr+1) )
     ENDIF
-!
-!-- Pre-set masks for regional statistics. Default is the total model domain.
-!-- Ghost points are excluded because counting values at the ghost boundaries would bias the
-!-- statistics.
-    rmask = 1.0_wp
-    rmask(:,nxlg:nxl-1,:) = 0.0_wp;  rmask(:,nxr+1:nxrg,:) = 0.0_wp
-    rmask(nysg:nys-1,:,:) = 0.0_wp;  rmask(nyn+1:nyng,:,:) = 0.0_wp
-!
-!-- Following array is required for perturbation pressure within the iterative pressure solvers. For
-!-- the multistep schemes (Runge-Kutta), array p holds the weighted average of the substeps and
-!-- cannot be used in the Poisson solver.
-    IF ( psolver == 'sor' )  THEN
-       ALLOCATE( p_loc(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-    ELSEIF ( psolver(1:9) == 'multigrid' )  THEN
-!
-!--    For performance reasons, multigrid is using one ghost layer only
-       ALLOCATE( p_loc(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
+
+    ALLOCATE( d(nzb+1:nzta,nys:nyna,nxl:nxra),             &
+              e_1(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),      &
+              e_2(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),      &
+              e_3(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),      &
+              kh_1(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),     &
+              km_1(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),     &
+              p(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),        &
+              pt_1(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),     &
+              pt_2(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),     &
+              pt_3(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),     &
+              tend(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),     &
+              u_1(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1+uxrp), &
+              u_2(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1+uxrp), &
+              u_3(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1+uxrp), &
+              v_1(nzb:nzt+1,nys-1:nyn+1+vynp,nxl-1:nxr+1), &
+              v_2(nzb:nzt+1,nys-1:nyn+1+vynp,nxl-1:nxr+1), &
+              v_3(nzb:nzt+1,nys-1:nyn+1+vynp,nxl-1:nxr+1), &
+              w_1(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),      &
+              w_2(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),      &
+              w_3(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
+
+    IF ( timestep_scheme(1:5) /= 'runge' )  THEN
+       ALLOCATE( kh_2(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1), &
+                 km_2(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
     ENDIF
 
-!
-!-- Array for storing constant coeffficients of the tridiagonal solver
-    IF ( psolver == 'poisfft' )  THEN
-       ALLOCATE( tri(nxl_z:nxr_z,nys_z:nyn_z,0:nz-1,2) )
-       ALLOCATE( tric(nxl_z:nxr_z,nys_z:nyn_z,0:nz-1) )
+    IF ( moisture  .OR.  passive_scalar ) THEN
+!
+!--    2D-moisture/scalar arrays
+       ALLOCATE ( qs(nys-1:nyn+1,nxl-1:nxr+1),     &
+                  qsws_1(nys-1:nyn+1,nxl-1:nxr+1) )
+
+       IF ( timestep_scheme(1:5) /= 'runge' )  THEN
+          ALLOCATE( qsws_2(nys-1:nyn+1,nxl-1:nxr+1) )
+       ENDIF
+!
+!--    3D-moisture/scalar arrays
+       ALLOCATE( q_1(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1), &
+                 q_2(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1), &
+                 q_3(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
+
+!
+!--    3D-arrays needed for moisture only
+       IF ( moisture )  THEN
+          ALLOCATE( vpt_1(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
+
+          IF ( timestep_scheme(1:5) /= 'runge' )  THEN
+             ALLOCATE( vpt_2(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
+          ENDIF
+
+          IF ( cloud_physics ) THEN
+!
+!--          Liquid water content
+             ALLOCATE ( ql_1(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
+          ENDIF
+
+          IF ( cloud_droplets )  THEN
+!
+!--          Liquid water content, change in liquid water content,
+!--          real volume of particles (with weighting), volume of particles
+             ALLOCATE ( ql_1(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1), &
+                        ql_2(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1), &
+                        ql_v(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1), &
+                        ql_vp(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
+          ENDIF
+
+       ENDIF
+
     ENDIF
 
-    IF ( humidity )  THEN
-!
-!--    3D-humidity
-       ALLOCATE( q_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                               &
-                 q_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                               &
-                 q_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                               &
-                 vpt_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+!
+!-- 3D-array for storing the dissipation, needed for calculating the sgs
+!-- particle velocities
+    IF ( use_sgs_for_particles )  THEN
+       ALLOCATE ( diss(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
     ENDIF
 
-    IF ( passive_scalar )  THEN
-
-!
-!--    3D scalar arrays
-       ALLOCATE( s_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                               &
-                 s_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                               &
-                 s_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-
+    IF ( dt_dosp /= 9999999.9 )  THEN
+       ALLOCATE( spectrum_x( 1:nx/2, 1:10, 1:10 ), &
+                 spectrum_y( 1:ny/2, 1:10, 1:10 ) )
     ENDIF
 
 !
-!-- Allocate and set 1d-profiles for Stokes drift velocity. It may be set to non-zero values later
-!-- in ocean_init.
-    ALLOCATE( u_stokes_zu(nzb:nzt+1), u_stokes_zw(nzb:nzt+1),                                      &
-              v_stokes_zu(nzb:nzt+1), v_stokes_zw(nzb:nzt+1) )
-    u_stokes_zu(:) = 0.0_wp
-    u_stokes_zw(:) = 0.0_wp
-    v_stokes_zu(:) = 0.0_wp
-    v_stokes_zw(:) = 0.0_wp
-
-!
-!-- Allocation of anelastic and Boussinesq approximation specific arrays
-    ALLOCATE( p_hydrostatic(nzb:nzt+1) )
-    ALLOCATE( rho_air(nzb:nzt+1) )
-    ALLOCATE( rho_air_zw(nzb:nzt+1) )
-    ALLOCATE( drho_air(nzb:nzt+1) )
-    ALLOCATE( drho_air_zw(nzb:nzt+1) )
-!
-!-- Density profile calculation for anelastic and Boussinesq approximation.
-!-- In case of a Boussinesq approximation, a constant density is calculated mainly for output
-!-- purposes. This density does not need to be considered in the model's system of equations.
-    IF ( TRIM( approximation ) == 'anelastic' )  THEN
-       DO  k = nzb, nzt+1
-          p_hydrostatic(k) = barometric_formula(zu(k), pt_surface *                                &
-                                                exner_function(surface_pressure * 100.0_wp),       &
-                                                surface_pressure * 100.0_wp)
-
-          rho_air(k) = ideal_gas_law_rho_pt(p_hydrostatic(k), pt_init(k))
-       ENDDO
-
-       DO  k = nzb, nzt
-          rho_air_zw(k) = 0.5_wp * ( rho_air(k) + rho_air(k+1) )
-       ENDDO
-
-       rho_air_zw(nzt+1)  = rho_air_zw(nzt) + 2.0_wp * ( rho_air(nzt+1) - rho_air_zw(nzt)  )
+!-- Initial assignment of the pointers
+    IF ( timestep_scheme(1:5) /= 'runge' )  THEN
+
+       rif_m  => rif_1;   rif  => rif_2
+       shf_m  => shf_1;   shf  => shf_2
+       usws_m => usws_1;  usws => usws_2
+       vsws_m => vsws_1;  vsws => vsws_2
+       e_m  => e_1;   e  => e_2;   e_p  => e_3;   te_m  => e_3
+       kh_m => kh_1;  kh => kh_2
+       km_m => km_1;  km => km_2
+       pt_m => pt_1;  pt => pt_2;  pt_p => pt_3;  tpt_m => pt_3
+       u_m  => u_1;   u  => u_2;   u_p  => u_3;   tu_m  => u_3
+       v_m  => v_1;   v  => v_2;   v_p  => v_3;   tv_m  => v_3
+       w_m  => w_1;   w  => w_2;   w_p  => w_3;   tw_m  => w_3
+
+       IF ( moisture  .OR.  passive_scalar )  THEN
+          qsws_m => qsws_1;  qsws => qsws_2
+          q_m    => q_1;     q    => q_2;     q_p => q_3;     tq_m => q_3
+          IF ( moisture )        vpt_m  => vpt_1;   vpt  => vpt_2
+          IF ( cloud_physics )   ql   => ql_1
+          IF ( cloud_droplets )  THEN
+             ql   => ql_1
+             ql_c => ql_2
+          ENDIF
+       ENDIF
 
     ELSE
-       DO  k = nzb, nzt+1
-          p_hydrostatic(k) = barometric_formula(zu(nzb), pt_surface *                              &
-                                                exner_function(surface_pressure * 100.0_wp),       &
-                                                surface_pressure * 100.0_wp)
-
-          rho_air(k) = ideal_gas_law_rho_pt(p_hydrostatic(k), pt_init(nzb))
-       ENDDO
-
-       DO  k = nzb, nzt
-          rho_air_zw(k) = 0.5_wp * ( rho_air(k) + rho_air(k+1) )
-       ENDDO
-
-       rho_air_zw(nzt+1)  = rho_air_zw(nzt) + 2.0_wp * ( rho_air(nzt+1) - rho_air_zw(nzt)  )
+
+       rif  => rif_1
+       shf  => shf_1
+       usws => usws_1
+       vsws => vsws_1
+       e    => e_1;   e_p  => e_2;   te_m  => e_3;   e_m  => e_3
+       kh   => kh_1
+       km   => km_1
+       pt   => pt_1;  pt_p => pt_2;  tpt_m => pt_3;  pt_m => pt_3
+       u    => u_1;   u_p  => u_2;   tu_m  => u_3;   u_m  => u_3
+       v    => v_1;   v_p  => v_2;   tv_m  => v_3;   v_m  => v_3
+       w    => w_1;   w_p  => w_2;   tw_m  => w_3;   w_m  => w_3
+
+       IF ( moisture  .OR.  passive_scalar )  THEN
+          qsws   => qsws_1
+          q      => q_1;     q_p  => q_2;     tq_m => q_3;    q_m => q_3
+          IF ( moisture )        vpt  => vpt_1
+          IF ( cloud_physics )   ql   => ql_1
+          IF ( cloud_droplets )  THEN
+             ql   => ql_1
+             ql_c => ql_2
+          ENDIF
+       ENDIF
 
     ENDIF
-!
-!-- Compute the inverse density array in order to avoid expencive divisions
-    drho_air    = 1.0_wp / rho_air
-    drho_air_zw = 1.0_wp / rho_air_zw
-
-!
-!-- Allocation of flux conversion arrays
-    ALLOCATE( heatflux_input_conversion(nzb:nzt+1) )
-    ALLOCATE( waterflux_input_conversion(nzb:nzt+1) )
-    ALLOCATE( momentumflux_input_conversion(nzb:nzt+1) )
-    ALLOCATE( heatflux_output_conversion(nzb:nzt+1) )
-    ALLOCATE( waterflux_output_conversion(nzb:nzt+1) )
-    ALLOCATE( momentumflux_output_conversion(nzb:nzt+1) )
-
-!
-!-- Calculate flux conversion factors according to approximation and in-/output mode
-    DO  k = nzb, nzt+1
-
-        IF ( TRIM( flux_input_mode ) == 'kinematic' )  THEN
-            heatflux_input_conversion(k)      = rho_air_zw(k)
-            waterflux_input_conversion(k)     = rho_air_zw(k)
-            momentumflux_input_conversion(k)  = rho_air_zw(k)
-        ELSEIF ( TRIM( flux_input_mode ) == 'dynamic' ) THEN
-            heatflux_input_conversion(k)      = 1.0_wp / c_p
-            waterflux_input_conversion(k)     = 1.0_wp / l_v
-            momentumflux_input_conversion(k)  = 1.0_wp
-        ENDIF
-
-        IF ( TRIM( flux_output_mode ) == 'kinematic' )  THEN
-            heatflux_output_conversion(k)     = drho_air_zw(k)
-            waterflux_output_conversion(k)    = drho_air_zw(k)
-            momentumflux_output_conversion(k) = drho_air_zw(k)
-        ELSEIF ( TRIM( flux_output_mode ) == 'dynamic' ) THEN
-            heatflux_output_conversion(k)     = c_p
-            waterflux_output_conversion(k)    = l_v
-            momentumflux_output_conversion(k) = 1.0_wp
-        ENDIF
-
-        IF ( .NOT. humidity ) THEN
-            waterflux_input_conversion(k)  = 1.0_wp
-            waterflux_output_conversion(k) = 1.0_wp
-        ENDIF
-
-    ENDDO
-
-!
-!-- In case of multigrid method, compute grid lengths and grid factors for the grid levels with
-!-- respective density on each grid.
-    IF ( psolver(1:9) == 'multigrid' )  THEN
-
-       ALLOCATE( ddx2_mg(maximum_grid_level) )
-       ALLOCATE( ddy2_mg(maximum_grid_level) )
-       ALLOCATE( dzu_mg(nzb+1:nzt+1,maximum_grid_level) )
-       ALLOCATE( dzw_mg(nzb+1:nzt+1,maximum_grid_level) )
-       ALLOCATE( f1_mg(nzb+1:nzt,maximum_grid_level) )
-       ALLOCATE( f2_mg(nzb+1:nzt,maximum_grid_level) )
-       ALLOCATE( f3_mg(nzb+1:nzt,maximum_grid_level) )
-       ALLOCATE( rho_air_mg(nzb:nzt+1,maximum_grid_level) )
-       ALLOCATE( rho_air_zw_mg(nzb:nzt+1,maximum_grid_level) )
-
-       dzu_mg(:,maximum_grid_level) = dzu
-       rho_air_mg(:,maximum_grid_level) = rho_air
-!
-!--    Next line to ensure an equally spaced grid.
-       dzu_mg(1,maximum_grid_level) = dzu(2)
-       rho_air_mg(nzb,maximum_grid_level) = rho_air(nzb) + (rho_air(nzb) - rho_air(nzb+1))
-
-       dzw_mg(:,maximum_grid_level) = dzw
-       rho_air_zw_mg(:,maximum_grid_level) = rho_air_zw
-       nzt_l = nzt
-       DO  l = maximum_grid_level-1, 1, -1
-           dzu_mg(nzb+1,l) = 2.0_wp * dzu_mg(nzb+1,l+1)
-           dzw_mg(nzb+1,l) = 2.0_wp * dzw_mg(nzb+1,l+1)
-           rho_air_mg(nzb,l)    = rho_air_mg(nzb,l+1)    + ( rho_air_mg(nzb,l+1)    -              &
-                                                             rho_air_mg(nzb+1,l+1)    )
-           rho_air_zw_mg(nzb,l) = rho_air_zw_mg(nzb,l+1) + ( rho_air_zw_mg(nzb,l+1) -              &
-                                                             rho_air_zw_mg(nzb+1,l+1) )
-           rho_air_mg(nzb+1,l)    = rho_air_mg(nzb+1,l+1)
-           rho_air_zw_mg(nzb+1,l) = rho_air_zw_mg(nzb+1,l+1)
-           nzt_l = nzt_l / 2
-           DO  k = 2, nzt_l+1
-              dzu_mg(k,l) = dzu_mg(2*k-2,l+1) + dzu_mg(2*k-1,l+1)
-              dzw_mg(k,l) = dzw_mg(2*k-2,l+1) + dzw_mg(2*k-1,l+1)
-              rho_air_mg(k,l)    = rho_air_mg(2*k-1,l+1)
-              rho_air_zw_mg(k,l) = rho_air_zw_mg(2*k-1,l+1)
-           ENDDO
-       ENDDO
-
-       nzt_l = nzt
-       dx_l  = dx
-       dy_l  = dy
-       DO  l = maximum_grid_level, 1, -1
-          ddx2_mg(l) = 1.0_wp / dx_l**2
-          ddy2_mg(l) = 1.0_wp / dy_l**2
-          DO  k = nzb+1, nzt_l
-             f2_mg(k,l) = rho_air_zw_mg(k,l) / ( dzu_mg(k+1,l) * dzw_mg(k,l) )
-             f3_mg(k,l) = rho_air_zw_mg(k-1,l) / ( dzu_mg(k,l)   * dzw_mg(k,l) )
-             f1_mg(k,l) = 2.0_wp * ( ddx2_mg(l) + ddy2_mg(l) )                                     &
-                          * rho_air_mg(k,l) + f2_mg(k,l) + f3_mg(k,l)
-          ENDDO
-          nzt_l = nzt_l / 2
-          dx_l  = dx_l * 2.0_wp
-          dy_l  = dy_l * 2.0_wp
-       ENDDO
-
-    ENDIF
-
-!
-!-- 1D-array for large scale subsidence velocity
-    IF ( .NOT. ALLOCATED( w_subs ) )  THEN
-       ALLOCATE ( w_subs(nzb:nzt+1) )
-       w_subs = 0.0_wp
-    ENDIF
-
-!
-!-- Initial assignment of the pointers
-    IF ( .NOT. neutral )  THEN
-       pt => pt_1;  pt_p => pt_2;  tpt_m => pt_3
-    ELSE
-       pt => pt_1;  pt_p => pt_1;  tpt_m => pt_3
-    ENDIF
-    u  => u_1;   u_p  => u_2;   tu_m  => u_3
-    v  => v_1;   v_p  => v_2;   tv_m  => v_3
-    w  => w_1;   w_p  => w_2;   tw_m  => w_3
-
-    IF ( humidity )  THEN
-       q => q_1;  q_p => q_2;  tq_m => q_3
-       vpt  => vpt_1
-    ENDIF
-
-    IF ( passive_scalar )  THEN
-       s => s_1;  s_p => s_2;  ts_m => s_3
-    ENDIF
-
-!
-!-- Initialize surface arrays
-    CALL init_surface_arrays
-!
-!-- Allocate arrays for other modules
-    CALL module_interface_init_arrays
-
-
-!
-!-- Allocate arrays containing the RK coefficient for calculation of perturbation pressure and
-!-- turbulent fluxes. At this point values are set for pressure calculation during initialization
-!-- (where no timestep is done). Further below the values needed within the timestep scheme will be
-!-- set.
-    ALLOCATE( weight_substep(1:intermediate_timestep_count_max),                                   &
-              weight_pres(1:intermediate_timestep_count_max) )
-    weight_substep = 1.0_wp
-    weight_pres    = 1.0_wp
-    intermediate_timestep_count = 0  ! needed when simulated_time = 0.0
-
-    IF ( debug_output )  CALL debug_message( 'allocating arrays', 'end' )
-
-!
-!-- Initialize time series
-    ts_value = 0.0_wp
-
-!
-!-- Initialize local summation arrays for routine flow_statistics.
-!-- This is necessary because they may not yet have been initialized when they are called from
-!-- flow_statistics (or - depending on the chosen model run - are never initialized)
-    sums_divnew_l  = 0.0_wp
-    sums_divold_l  = 0.0_wp
-    sums_l_l       = 0.0_wp
-    sums_wsts_bc_l = 0.0_wp
 
 !
 !-- Initialize model variables
-    IF ( TRIM( initializing_actions ) /= 'read_restart_data'  .AND.                                &
-         TRIM( initializing_actions ) /= 'cyclic_fill' )  THEN
-!
-!--    Initialization with provided input data derived from larger-scale model
-       IF ( INDEX( initializing_actions, 'inifor' ) /= 0 )  THEN
-          IF ( debug_output )  CALL debug_message( 'initializing with INIFOR', 'start' )
-!
-!--       Read initial 1D profiles or 3D data from NetCDF file, depending on the provided
-!--       level-of-detail.
-!--       At the moment, only u, v, w, pt and q are provided.
-          CALL netcdf_data_input_init_3d
-!
-!--       Please note, Inifor provides data from nzb+1 to nzt.
-!--       Bottom and top boundary conditions for Inifor profiles are already set (just after
-!--       reading), so that this is not necessary here.
-!--       Depending on the provided level-of-detail, initial Inifor data is either stored on data
-!--       type (lod=1), or directly on 3D arrays (lod=2).
-!--       In order to obtain also initial profiles in case of lod=2 (which is required for e.g.
-!--       damping), average over 3D data.
-          IF( init_3d%lod_u == 1 )  THEN
-             u_init = init_3d%u_init
-          ELSEIF( init_3d%lod_u == 2 )  THEN
-             ALLOCATE( init_l(nzb:nzt+1) )
-             DO  k = nzb, nzt+1
-                init_l(k) = SUM( u(k,nys:nyn,nxl:nxr) )
-             ENDDO
-             init_l = init_l / REAL( ( nx + 1 ) * ( ny + 1 ), KIND = wp )
-
-#if defined( __parallel )
-             CALL MPI_ALLREDUCE( init_l, u_init, nzt+1-nzb+1, MPI_REAL, MPI_SUM, comm2d, ierr )
-#else
-             u_init = init_l
-#endif
-             DEALLOCATE( init_l )
-
-          ENDIF
-
-          IF( init_3d%lod_v == 1 )  THEN
-             v_init = init_3d%v_init
-          ELSEIF( init_3d%lod_v == 2 )  THEN
-             ALLOCATE( init_l(nzb:nzt+1) )
-             DO  k = nzb, nzt+1
-                init_l(k) = SUM( v(k,nys:nyn,nxl:nxr) )
-             ENDDO
-             init_l = init_l / REAL( ( nx + 1 ) * ( ny + 1 ), KIND = wp )
-
-#if defined( __parallel )
-             CALL MPI_ALLREDUCE( init_l, v_init, nzt+1-nzb+1, MPI_REAL, MPI_SUM, comm2d, ierr )
-#else
-             v_init = init_l
-#endif
-             DEALLOCATE( init_l )
-          ENDIF
-          IF( .NOT. neutral )  THEN
-             IF( init_3d%lod_pt == 1 )  THEN
-                pt_init = init_3d%pt_init
-             ELSEIF( init_3d%lod_pt == 2 )  THEN
-                ALLOCATE( init_l(nzb:nzt+1) )
-                DO  k = nzb, nzt+1
-                   init_l(k) = SUM( pt(k,nys:nyn,nxl:nxr) )
-                ENDDO
-                init_l = init_l / REAL( ( nx + 1 ) * ( ny + 1 ), KIND = wp )
-
-#if defined( __parallel )
-                CALL MPI_ALLREDUCE( init_l, pt_init, nzt+1-nzb+1, MPI_REAL, MPI_SUM, comm2d, ierr )
-#else
-                pt_init = init_l
-#endif
-                DEALLOCATE( init_l )
-             ENDIF
-          ENDIF
-
-
-          IF( humidity )  THEN
-             IF( init_3d%lod_q == 1 )  THEN
-                q_init = init_3d%q_init
-             ELSEIF( init_3d%lod_q == 2 )  THEN
-                ALLOCATE( init_l(nzb:nzt+1) )
-                DO  k = nzb, nzt+1
-                   init_l(k) = SUM( q(k,nys:nyn,nxl:nxr) )
-                ENDDO
-                init_l = init_l / REAL( ( nx + 1 ) * ( ny + 1 ), KIND = wp )
-
-#if defined( __parallel )
-                CALL MPI_ALLREDUCE( init_l, q_init, nzt+1-nzb+1, MPI_REAL, MPI_SUM, comm2d, ierr )
-#else
-                q_init = init_l
-#endif
-                DEALLOCATE( init_l )
-             ENDIF
-          ENDIF
-
-!
-!--       Write initial profiles onto 3D arrays.
-!--       Work-around, 3D initialization of u,v,w creates artificial structures which correlate with
-!--       the processor grid. The reason for this is still unknown. To work-around this, 3D
-!--       initialization will be effectively reduce to a 1D initialization where no such artificial
-!--       structures appear.
-          DO  i = nxlg, nxrg
-             DO  j = nysg, nyng
-                IF( init_3d%lod_u == 1  .OR.  init_3d%lod_u == 2 )  u(:,j,i) = u_init(:)
-                IF( init_3d%lod_v == 1  .OR.  init_3d%lod_u == 2 )  v(:,j,i) = v_init(:)
-                IF( .NOT. neutral  .AND.  ( init_3d%lod_pt == 1  .OR.  init_3d%lod_pt == 2 ) )     &
-                   pt(:,j,i) = pt_init(:)
-                IF( humidity  .AND.  ( init_3d%lod_q == 1  .OR.  init_3d%lod_q == 2 ) )            &
-                   q(:,j,i) = q_init(:)
-             ENDDO
-          ENDDO
-!
-!--       Set geostrophic wind components.
-          IF ( init_3d%from_file_ug )  THEN
-             ug(:) = init_3d%ug_init(:)
-          ENDIF
-          IF ( init_3d%from_file_vg )  THEN
-             vg(:) = init_3d%vg_init(:)
-          ENDIF
-!
-!--       Set bottom and top boundary condition for geostrophic wind
-          ug(nzt+1) = ug(nzt)
-          vg(nzt+1) = vg(nzt)
-          ug(nzb)   = ug(nzb+1)
-          vg(nzb)   = vg(nzb+1)
-!
-!--       Set inital w to 0
-          w = 0.0_wp
-
-          IF ( passive_scalar )  THEN
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   s(:,j,i) = s_init
-                ENDDO
-             ENDDO
-          ENDIF
-
-!
-!--       Set velocity components at non-atmospheric / oceanic grid points to zero.
-          u = MERGE( u, 0.0_wp, BTEST( wall_flags_total_0, 1 ) )
-          v = MERGE( v, 0.0_wp, BTEST( wall_flags_total_0, 2 ) )
-          w = MERGE( w, 0.0_wp, BTEST( wall_flags_total_0, 3 ) )
-!
-!--       Initialize surface variables, e.g. friction velocity, momentum fluxes, etc.
-          CALL  init_surfaces
-
-          IF ( debug_output )  CALL  debug_message( 'initializing with INIFOR', 'end' )
-!
-!--    Initialization via computed 1D-model profiles
-       ELSEIF ( INDEX( initializing_actions, 'set_1d-model_profiles' ) /= 0 )  THEN
-
-          IF ( debug_output )  CALL  debug_message( 'initializing with 1D model profiles', 'start' )
+    IF ( TRIM( initializing_actions ) /= 'read_restart_data' )  THEN
+!
+!--    First model run of a possible job queue.
+!--    Initial profiles of the variables must be computes.
+       IF ( INDEX( initializing_actions, 'set_1d-model_profiles' ) /= 0 )  THEN
 !
 !--       Use solutions of the 1D model as initial profiles,
